/* global BDF */

BDF.Ajax = {};

BDF.Ajax.loadLangConfiguration = function (langConfigurationCallback) {
    $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "langconfiguration"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "langConfiguration", langConfigurationCallback);
        }
    });
};

BDF.Ajax.loadPathConfiguration = function (pathConfigurationCallback) {
    $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "pathconfiguration"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "pathConfiguration", pathConfigurationCallback);
        }
    });
};

BDF.Ajax.loadTableExportArray = function (tableExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "tableexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "tableExportArray", tableExportArrayCallback);
        }
    });
};

BDF.Ajax.loadTableExportContent = function (tableExportName, path, tableExportContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "tableexport-content",
            tableexport: tableExportName,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "tableExportContent", tableExportContentCallback);
        }
    });
};

BDF.Ajax.loadPatternArrayMap = function (patternArrayMapCallback) {
     $.ajax({
        url: BDF.URL + "main",
        data: {
            json: "availablepatterns"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "patternArrayMap", patternArrayMapCallback);
        }
    });
};

BDF.Ajax.loadSubsetTreeMap = function (categories, withDetails, subsetTreeMapCallback) {
     $.ajax({
        url: BDF.URL + "configuration",
        data: {
            json: "subsettree-map",
            categories: categories,
            withdetails: withDetails
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "subsetTreeMap", subsetTreeMapCallback);
        }
    });
};

BDF.Ajax.loadScrutariExportArray = function (scrutariExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "scrutariexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "scrutariExportArray", scrutariExportArrayCallback);
        }
    });
};

BDF.Ajax.loadSqlExportArray = function (sqlExportArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "sqlexport-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "sqlExportArray", sqlExportArrayCallback);
        }
    });
};

BDF.Ajax.loadRoleArray = function (roleArrayCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "role-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "roleArray", roleArrayCallback);
        }
    });
};

BDF.Ajax.loadBalayageArray = function (balayageArrayCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "balayage-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "balayageArray", balayageArrayCallback);
        }
    });
};

BDF.Ajax.loadBalayageContent = function (balayageName, path, balayageContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "balayage-content",
            balayage: balayageName,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "balayageContent", balayageContentCallback);
        }
    });
};

BDF.Ajax.loadTransformationDescription = function (transformationDescriptionCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-description"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "transformationDescription", transformationDescriptionCallback);
        }
    });
};

BDF.Ajax.loadTransformationDescriptionMap = function (keys, transformationDescriptionMapCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-descriptionmap",
            keys: keys
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "transformationDescriptionMap", transformationDescriptionMapCallback);
        }
    });
};

BDF.Ajax.loadTemplateDescription = function (templateKey, templateDescriptionCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-templatedescription",
            template: templateKey
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "templateDescription", templateDescriptionCallback);
        }
    });
};

BDF.Ajax.loadTemplateContent = function (templateKey, path, templateContentCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "transformation-templatecontent",
            template: templateKey,
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "templateContent", templateContentCallback);
        }
    });
};

BDF.Ajax.loadScrutariExport = function (scrutariExportName, scrutariExportCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "scrutariexport",
            scrutariexport: scrutariExportName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "scrutariExport", scrutariExportCallback);
        }
    });
};

BDF.Ajax.loadSqlExport = function (sqlExportName, sqlExportCallback) {
    $.ajax({
        url: BDF.URL + "exportation",
        data: {
            json: "sqlexport",
            sqlexport: sqlExportName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "sqlExport", sqlExportCallback);
        }
    });
};

BDF.Ajax.loadRole = function (roleName, roleCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "role",
            role: roleName
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "role", roleCallback);
        }
    });
};

BDF.Ajax.loadResourceTree = function (resourceTreeCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "resource-tree"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "resourceTree", resourceTreeCallback);
        }
    });
};

BDF.Ajax.loadStreamText = function (resourcePath, streamTextCallback) {
    $.ajax({
        url: BDF.URL + "administration",
        data: {
            json: "streamtext",
            path: resourcePath
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "streamText", streamTextCallback);
        }
    });
};

BDF.Ajax.loadMementoUnitInfoArray = function (mementoUnitInfoArrayCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
            json: "memento-unitinfo-array"
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "mementoUnitInfoArray", mementoUnitInfoArrayCallback);
        }
    });
};

BDF.Ajax.loadMementoUnit = function (path, mementoUnitCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
            json: "memento-unit",
            path: path
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "mementoUnit", mementoUnitCallback);
        }
    });
};

BDF.Ajax.loadTable = function (tableExportName, subset, tableCallback) {
    $.ajax({
        url: BDF.URL + "main",
        data: {
           json: "table",
           tableexport: tableExportName,
           subset: subset
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "table", tableCallback);
        }
    });
};

BDF.Ajax.loadHistory = function (subset, id, historyCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
           json: "history",
           subset: subset,
           id: id
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "history", historyCallback);
        }
    });
};

BDF.Ajax.loadRevisionFicheMap = function (corpus, id, revisions, revisionFicheMapCallback) {
    $.ajax({
        url: BDF.URL + "misc",
        data: {
           json: "revision-fiche",
           corpus: corpus,
           id: id,
           revisions: revisions
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "revisionFicheMap", revisionFicheMapCallback);
        }
    });
};

BDF.Ajax.loadUi = function (corpus, uiCallback) {
    $.ajax({
        url: BDF.URL + "corpus",
        data: {
           json: "ui",
           corpus: corpus
        },
        dataType: BDF.jsonDataType,
        success: function (data, textStatus) {
            BDF.Ajax.success(data, "ui", uiCallback);
        }
    });
};

BDF.Ajax.success = function (data, objectName, objectCallback) {
    if (data.commandMessage) {
        if (!BDF.Ajax.checkError(data)) {
            return false;
        }
    }
    if (!data.hasOwnProperty(objectName)) {
        $.error("BDF Error: " + objectName + " object is missing in json response");
        return false;
    } else {
        objectCallback(data[objectName], data);
        return true;
    }
};

BDF.Ajax.checkError = function (data) {
    if (data.commandMessage) {
        if (data.commandMessage.type === "error") {
                var alertText = "";
                if (data.commandMessage.text) {
                    alertText = alertText + data.commandMessage.text;
                } else {
                    alertText = alertText + data.commandMessage.key;
                }
                if (data.commandMessage.multiErrorMessageArray) {
                    var array = data.commandMessage.multiErrorMessageArray;
                    for(var i = 0; i < array.length; i++) {
                        var obj = array[i];
                        alertText = alertText + "\n\n      - ";
                        if (obj.text) {
                            alertText = alertText + obj.text;
                        } else {
                            alertText = alertText + obj.key;
                        }
                    }
                }
                alert(alertText);
                return false;
        }
    }
    return true;
};
