/* FichothequeLib_API - Copyright (c) 2012-2019 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.fichotheque.exportation.table;

import java.util.List;
import net.fichotheque.SubsetKey;
import net.mapeadores.util.logging.MessageByLine;


/**
 *
 * @author Vincent Calame
 */
public interface TableExportContentDescription {

    public final static short OK_STATE = 1;
    public final static short UNKNOWN_NAME_STATE = 2;
    public final static short UNKNOWN_SUBSET_STATE = 3;
    public final static short EMPTY_STATE = 4;
    public final static short EMPTY_WITH_ERRORS_STATE = 5;
    public final static short OK_WITH_ERRORS_STATE = 6;

    public String getPath();

    public String getTableExportName();

    public short getState();

    /**
     * Peut être nul
     */
    public SubsetKey getSubsetKey();

    public TableDef getTableDef();

    /**
     * Ordonné suivant le numéro de ligne
     */
    public List<MessageByLine> getMessageByLineList();

    public boolean isEditable();

}
