/* FichothequeLib_API - Copyright (c) 2006-2016 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.fichotheque.sphere;

import java.text.ParseException;
import net.fichotheque.ExistingIdException;
import net.fichotheque.FichothequeEditor;
import net.fichotheque.sphere.metadata.SphereMetadataEditor;
import net.mapeadores.util.models.EmailCore;
import net.mapeadores.util.models.PersonCore;


/**
 *
 * @author Vincent Calame
 */
public interface SphereEditor {

    public Sphere getSphere();

    public FichothequeEditor getFichothequeEditor();

    public SphereMetadataEditor getSphereMetadataEditor();

    /**
     * si id &lt; 1, un nouvel identifiant est attribué
     */
    public Redacteur createRedacteur(int id, String login) throws ExistingIdException, ParseException;

    public boolean setLogin(Redacteur redacteur, String newLogin) throws ExistingIdException, ParseException;

    /**
     * Doit modifier CourrielCore si précédemment
     * courrielCore.getAddrTitle().equals(PersonneUtils.toString(personneCore,
     * PersonneConstants.NORMAL_STYLE));
     */
    public boolean setPersonCore(Redacteur redacteur, PersonCore personCore);

    /**
     * Si courrielCore.getAddrTitle() est de longueur nulle, il prend la valeur
     * de PersonneUtils.toString(getPersonneCore(),
     * PersonneConstants.NORMAL_STYLE)
     */
    public boolean setEmailCore(Redacteur redacteur, EmailCore emailCore);

    public boolean removeRedacteur(Redacteur redacteur);

    public boolean setActive(Redacteur redacteur, boolean actif);

}
