/* FichothequeLib_API - Copyright (c) 2011-2021 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.fichotheque.utils.selection;

import net.fichotheque.selection.CroisementCondition;
import net.fichotheque.selection.DocumentQuery;


/**
 *
 * @author Vincent Calame
 */
class DocumentSelectEngine {

    private final CroisementCondition croisementCondition;

    DocumentSelectEngine(DocumentQuery documentQuery) {
        this.croisementCondition = documentQuery.getCroisementCondition();
    }

    void filter(FilteredCroisementBuilder builder) {
        if (!isSelected()) {
            return;
        }
        builder.testCondition(croisementCondition);
    }

    boolean isSelected() {
        return true;
    }

}
